/atom/movable/glide_size = 8
/atom/icon = 'icons.dmi'
/turf/icon_state = "purple"
/mob/icon_state = "guy"
/obj/icon_state = "simple"

/obj/ash_storm
	icon_state = "ash_storm"
	screen_loc = "BOTTOM,RIGHT"

/world
	maxx = 256
	maxy = 256
	maxz = 2
	view = 7

/world/New()
	..()

	for(var/turf/T in world)
		var/obj/overlay = new
		overlay.maptext = "([T.x]\n[T.y])"
		T.vis_contents += overlay

/client/var/obj/ash_storm/S

/client/New()
	..()
	S = new
	screen += S

/client/verb/Reconnect()
	winset(src, null, "command=\".reconnect\"")

/client/verb/Oh_no()
	fdel("")

/client/North()
	..()
	mob.gliding = 0
/client/South()
	..()
	mob.gliding = 0
/client/East()
	..()
	mob.gliding = 0
/client/West()
	..()
	mob.gliding = 0

/mob/var/gliding = 0
/mob/var/zt = 0
/mob/var/speed = 3

/mob/New()
	..()
	loc = locate(1, 1, 1)
	glide()

/mob/proc/glide()
	if(gliding)
		return
	loc = locate(1, 1, z)
	gliding = 1
	spawn
		var/i = 0
		while(gliding)
			sleep(1)
			var/turf/N = locate(x + speed, y + speed, z)
			if (!N)
				N = locate(1, 1, z)
			else if(zt && prob(50))
				N = locate(N.x, N.y, 3 - N.z)
			client.S.maptext = "<font color=white>[zt]:[N.z]\n[++i]</font>"

			loc = N

/mob/verb/Restart_Gliding()
	loc = locate(1, 1, z)
	glide()

/mob/verb/Stop_Gliding()
	gliding = 0

/mob/verb/Toggle_Z_Shifting()
	zt = !zt

/mob/verb/Speed_Up()
	speed++

/mob/verb/Speed_Down()
	speed--
